-- everything teams related
tsrb2kr.Teams_AssignPlayers = function()
	if (leveltime != 105) then return end	-- past the point of this
	server.tsr_server.teams = {{}, {}, {}, {}, {}}	-- setup teams table
	server.tsr_server.playersperteam = 3
	
	-- get players in a table
	local assigntable = {}
	for p in players.iterate
		if (p.spectator) then continue end
		assigntable[#assigntable+1] = p
	end
	
	-- assign teams in a linear, random fashion
	if (#assigntable)
		for i = #assigntable, 1, -1
			local n = P_RandomRange(1, i)
			tsrb2kr.AssignTeam(assigntable[n]) -- get a random player
			table.remove(assigntable, n)
		end
	end
	S_StartSound(nil, sfx_kc48)
end

tsrb2kr.Teams_Ragespec = function()
	for i = 1, #server.tsr_server.teams
		for k, v in ipairs(server.tsr_server.teams[i])
			if not (v and v.valid)
			or (v.spectator)
				table.remove(server.tsr_server.teams[i], k)
				if (v and v.valid)
					v.tsr.team = nil
				end
			end
		end
	end
	
	for p in players.iterate
		if (p.spectator) then continue end
		if (p.tsr.team) then continue end

		tsrb2kr.AssignTeam(p)
	end
end

tsrb2kr.Teams_Sorting = function()
	server.tsr_server.sortedteams = {}
	local sortedteams = server.tsr_server.sortedteams	-- laziness ahoy
	
	-- get the teams scores (and make sure team is valid too a.k.a has members) and get them sorted
	for i = 1, 5 
        if not #server.tsr_server.teams[i] then continue end
        sortedteams[#sortedteams+1] = {i, tsrb2kr.ReturnTeamPoints(i)}
    end
    table.sort(sortedteams, function(a, b) return (a[2] or 0) > (b[2] or 0) end)
	
	-- now we store their absolute ranks, ties accounted for
	// this makes the code into a mess. ...Too bad!
	for i = 1, #sortedteams
		local pos = i
		
		-- if there's a tie, just grab the rank of the prev team;
		-- constantly check over and over so we can get multiple ties if need be
		local prevteam_i = 1
		local prevteam = sortedteams[i-prevteam_i]

		while (prevteam)
			if (sortedteams[i][2] == prevteam[2])
				pos = i-prevteam_i
			end
			-- search for the next team in line
			prevteam_i = $+1
			prevteam = sortedteams[i-prevteam_i]
		end

		sortedteams[i][3] = pos
	end
end

tsrb2kr.Teams_Recognition = function(p)
	-- team colours
	if (tsrb2kr.cv_tc.value)
		if (p.tsr.team)
			p.tsr.oldskincolor = $ or p.skincolor

			tsrb2kr.SmartSetColor(p, false, tsrb2kr.ReturnTeamColor(p.tsr.team))
			p.skincolor = tsrb2kr.ReturnTeamColor(p.tsr.team)
		else
			if (p.tsr.oldskincolor)
				tsrb2kr.SmartSetColor(p, false, p.tsr.oldskincolor)
				p.skincolor = p.tsr.oldskincolor

				p.tsr.oldskincolor = nil
			end
		end
	else
		if (p.tsr.oldskincolor)
			tsrb2kr.SmartSetColor(p, false, p.tsr.oldskincolor)
			p.skincolor = p.tsr.oldskincolor

			p.tsr.oldskincolor = nil
		end
	end
	
	-- all of this is team related functions
	if not (p.tsr.team) then return end
	p.tsr.displayteam = $ and $-1
	
	-- we need mo to be valid here on
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	if not mo.tsr_marker or not mo.tsr_marker.valid
		mo.tsr_marker = P_SpawnMobj(mo.x, mo.y, mo.z, MT_TSR_MARKER)
		mo.tsr_marker.target = mo
		mo.tsr_marker.color = tsrb2kr.ReturnTeamColor(p.tsr.team)
		mo.tsr_marker.flags2 = $|MF2_DONTDRAW
	end
end

tsrb2kr.Framework_HandleTeams = function()
	if (server.tsr_server.tourneyround) return end	-- has it's own handling
	
	tsrb2kr.Teams_AssignPlayers()
	tsrb2kr.Teams_Ragespec()
	tsrb2kr.Teams_Sorting()
	for p in players.iterate
		tsrb2kr.Teams_Recognition(p)
	end
end