-- everything ultimate related
tsrb2kr.Ultimates_HUDVariables = function(p)
	if (p.tsr.ultimategauge == nil) then p.tsr.ultimategauge = 0 end

	local dest_length = min(1000, server.tsr_server.ultimates[p.tsr.team])
	if (p.tsr.ultimatebuffer)
		dest_length = 1000
	end

	if (p.mo.tsr_ultimateon)
		dest_length = p.tsr.teamultimate
		p.tsr.ultimategauge = min(p.tsr.teamultimate, $)
	end

	if (p.tsr.ultimategauge != dest_length)
		if (p.tsr.ultimategauge < dest_length)
			p.tsr.ultimategauge = $+max(1, abs((dest_length - p.tsr.ultimategauge)/12))
		else
			p.tsr.ultimategauge = $-max(1, abs((dest_length - p.tsr.ultimategauge)/12))
		end
	end

	-- play sfx
	local length = p.tsr.ultimategauge*((splitscreen) and ((splitscreen) > 1 and 18 or 25) or 34)/1000
	if (p.tsr.oldultimategauge and length > p.tsr.oldultimategauge)
		S_StartSound(nil, sfx_ptally, p)
	end
	p.tsr.oldultimategauge = length
end

tsrb2kr.Ultimates_Freeplay = function()
	local freeplay = true
	
	local playercount = 0
	for p in players.iterate
		if (p.spectator) then continue end
		
		playercount = $+1
		if (playercount > 1) then freeplay = false break end
	end
	if not (freeplay) then return end
	if not (leveltime > (6*TICRATE + (3*TICRATE/4))) then return end
	
	for p in players.iterate
		if (p.tsr.inputs[BT_CUSTOM3])
			if (p.tsr.teamultimate)
				p.tsr.teamultimate = 1000
			else
				server.tsr_server.ultimates[p.tsr.team] = 1000
			end
		end
	end
end

tsrb2kr.Ultimates_FillMessages = function(p)
    if not (p.tsr.teammsg_time) then return end
	
	p.tsr.teammsg_time = $-1
	if not (p.tsr.teammsg_time)
		p.tsr.teammsg = nil
		p.tsr.teammsg_nooverwrite = nil    -- clear that
	end
end

tsrb2kr.Ultimates_FullMeter = function(p, ultcharge)
    if (ultcharge >= 1000)
		if (p.tsr.ultimateget == nil)
			p.tsr.ultimateget = 80
			if not (p.exiting or (p.pflags & PF_TIMEOVER))
				S_StartSoundAtVolume(nil, sfx_s3kac, 130, p)
			end
		else
			p.tsr.ultimateget = max(0, $-1)
		end
    end
end

tsrb2kr.Ultimates_Decay = function(p, ultcharge)
	local mo = p.mo
	if (mo and mo.valid) and (mo.tsr_ultimateon) then return end
	
	if (p.tsr.ultimatedecaytimer == nil)
		p.tsr.ultimatedecaytimer = 15*TICRATE
	else
		if (p.tsr.ultimatedecaytimer)
			p.tsr.ultimatedecaytimer = $-1
			//print("Ultimate Decay Timer: "..p.tsr.ultimatedecaytimer)
		else
			if (p.tsr.decayedultimate == nil)
				p.tsr.decayedultimate = 1000
				if not (p.exiting or (p.pflags & PF_TIMEOVER))
					S_StartSound(nil, sfx_kc59, p)
				end
			end

			if (p.tsr.decayedultimate)
				p.tsr.decayedultimate = $-2
				-- decay sound
				local decay_sound_timer = (1000-p.tsr.decayedultimate)/2
				if ((p.tsr.decayedultimate < 9950) and (decay_sound_timer%8 == 4))
				and not (p.exiting or (p.pflags & PF_TIMEOVER))
					S_StartSoundAtVolume(nil, sfx_s3k8c, 192, p)
				end
				//print("Ultimate Decay: "..p.tsr.decayedultimate)
			else
				-- get rid of ultimate now
				if (ultcharge >= 1000)
					server.tsr_server.ultimates[p.tsr.team] = 0	-- reset team ult charge if it was full
				end
				
				p.tsr.ultimatebuffer = nil
				p.tsr.ultimateget = nil
				p.tsr.decayedultimate = nil
				p.tsr.ultimatedecaytimer = nil
				if not (p.exiting or (p.pflags & PF_TIMEOVER))
					S_StartSound(nil, sfx_kc59, p)
				end
			end
		end
	end
end

tsrb2kr.Ultimates_Signalling = function(p)
	local notUsing = true
	for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
		if (v == p) then continue end
		if (v.mo.tsr_ultimateon) then notUsing = false break end
	end

	-- i wanna ulttt!!!!
	if (notUsing)    -- no one is ulting already, that's silly
	and (#server.tsr_server.teams[p.tsr.team] > 1)    -- being lonely is hard
	and not (p.tsr.teammsg_nooverwrite)    -- this is already happening.
	and not (p.exiting)					-- bruh
	and (p.tsr.inputs[BT_CUSTOM3] == 1)	-- no, you cant buffer this
		for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
			S_StartSound(nil, sfx_strpst, v)
		end
		tsrb2kr.FillUltimate(p, 0, "WANTS TO ULTIMATE!", {V_YELLOWMAP, V_ORANGEMAP}, nil, true)
	end
end

tsrb2kr.Ultimates_Activate = function(p, ultcharge)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	if (p.cmd.buttons & BT_CUSTOM2)	-- custom 2 activates the ultimate
	and not (mo.tsr_ultimateon)
	and not (p.exiting) -- nope, we've already finished
	and not (p.kartstuff[k_spinouttimer]) -- no spinout
	and not (p.kartstuff[k_squishedtimer]) -- no pancakes either
		if (ultcharge >= 1000)
			server.tsr_server.ultimates[p.tsr.team] = 0	-- reset team ult charge if it was full
		end
		
		p.tsr.ultimateget = nil
		p.tsr.ultimatebuffer = nil
		p.tsr.teamultimate = 1000	-- our own ultimate timer
		mo.tsr_ultimateon = true
		mo.tsr_ultimatespeed = 0
		mo.tsr_ultimatetime = TICRATE	-- time your ultimate!
		K_PlayPowerGloatSound(p.mo)
		K_DoSneaker(p)
		p.kartstuff[k_sneakertimer] = 8

		-- remove decay stuff
		p.tsr.decayedultimate = nil
		p.tsr.ultimatedecaytimer = nil

		-- ultimate message (with failsafes)
		p.tsr.teammsg_time = 0
		p.tsr.teammsg = nil
		p.tsr.teammsg_nooverwrite = nil
		
		-- get music
		local music = tsrb2kr.ultimatemusic[mo.skin] or "TSRGLR"
		S_ChangeMusic(music, true, p)
		
		-- 1st iteration to check if this is the first teammate ulting
		local firstUltimate = true
		for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
			if (v == p) then continue end

			if (v.mo.tsr_ultimateon) 
				firstUltimate = false 
				break 
			end
		end
			
		local colours = {SKINCOLOR_YELLOW, SKINCOLOR_GOLD, SKINCOLOR_SUPER5}	-- possible colours
		local rad = (mo.radius*2)>>FRACBITS	-- player radius
		local launch = 20
		
		if (firstUltimate)	-- this is the first ultimate
			mo.tsr_ultimatetimed = true
				
			S_StartSound(mo, sfx_supert)
			for i = 1, 48
				local newx = mo.x + (P_RandomRange(-rad, rad)<<FRACBITS)
				local newy = mo.y + (P_RandomRange(-rad, rad)<<FRACBITS)
				local newz = mo.z + (P_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)
					
				local spark = P_SpawnMobj(newx, newy, newz, MT_TSR_ULTIMATESPARK)
				spark.scale = mo.scale*2
				spark.color = colours[P_RandomRange(1, #colours)]
				spark.momx = (mo.momx*3/2) + P_RandomRange(-launch, launch)*spark.scale
				spark.momy = (mo.momy*3/2) + P_RandomRange(-launch, launch)*spark.scale
				spark.momz = mo.momz + P_RandomRange(7, 14)*spark.scale
			end
		else	-- we're not the first teammate ulting, iterate again to tell if we timed it right!
			for k, v in ipairs(server.tsr_server.teams[p.tsr.team])
				if (v == p) then continue end
					
				if (v.mo.tsr_ultimatetime) -- we've got a good rhythm going!
					mo.tsr_ultimatetimed = true
						
					S_StartSound(mo, sfx_supert)
					for i = 1, 48
						local newx = mo.x + (P_RandomRange(-rad, rad)<<FRACBITS)
						local newy = mo.y + (P_RandomRange(-rad, rad)<<FRACBITS)
						local newz = mo.z + (P_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)
							
						local spark = P_SpawnMobj(newx, newy, newz, MT_TSR_ULTIMATESPARK)
						spark.scale = mo.scale*2
						spark.color = colours[P_RandomRange(1, #colours)]
						spark.momx = (mo.momx*3/2) + P_RandomRange(-launch, launch)*spark.scale
						spark.momy = (mo.momy*3/2) + P_RandomRange(-launch, launch)*spark.scale
						spark.momz = mo.momz + P_RandomRange(7, 14)*spark.scale
					end
						
					break
				end
			end
		end
		
		local message = (not (firstUltimate) and mo.tsr_ultimatetimed) and "PERFECT!" or "ULTIMATE!"
		tsrb2kr.FillUltimate(p, 0, message, {V_YELLOWMAP, V_ORANGEMAP})
	end
end

tsrb2kr.Ultimates_PlayerThinker = function(p)
	local mo = p.mo
	
	p.tsr.teamultimate = $ or 0
	if not (mo.tsr_ultimateon) then return end
	
	-- ultimate timer, time your ultimate with your teammates!
	mo.tsr_ultimatetime = max(0, $-1)
	-- get ultimate info (timed, speed)
	local team = server.tsr_server.teams[p.tsr.team]
	local timed_ultimate = 0+(3-#team)	-- how many people timed the ultimate?
	for k, v in ipairs(team)
		if (v.mo and v.mo.valid)
			if (v.mo.tsr_ultimateon and v.mo.tsr_ultimatetimed)
				timed_ultimate = $+1
			end
		end
	end
	mo.tsr_ultimatespeed = max(timed_ultimate*(FRACUNIT/90), $)	-- max function here so it doesnt slow down mid ultimate!

	if not (mo.tracer and mo.tracer.type == MT_TUBEWAYPOINT)
		p.kartstuff[k_sneakertimer] = max(2, $)
		p.pflags = $|PF_ATTACKDOWN	-- calm down, no items during ultimate
			
		-- get speed here
		p.kartstuff[k_speedboost] = $ + mo.tsr_ultimatespeed
		if (P_IsObjectOnGround(p.mo)) then p.speed = mo.scale*11 end	-- easier turning
	end
	
	
	-- you're yellow now
	mo.colorized = (leveltime%4 == 0) and true or false
	mo.color = (leveltime%4 == 0) and SKINCOLOR_YELLOW or p.skincolor
	
	-- register animated icon
	if (hitfeed)
		if not HF_animIcon["K_HMTSR"] then HF_animIcon["K_HMTSR"] = {2, 2} end
	end
	mo.hf_overrideicon = "K_HMTSR"	-- hitfeed support
	
	-- spawn effects
	local colours = {SKINCOLOR_YELLOW, SKINCOLOR_GOLD, SKINCOLOR_SUPER5}	-- possible colours
	local rad = (mo.radius*2)>>FRACBITS	-- player radius
	for i = 1, (mo.tsr_ultimatetimed and 4 or 2)	-- invincibility but yellow/gold
		local newx = mo.x + mo.momx + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newy = mo.y + mo.momy + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newz = mo.z + mo.momz + (P_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)

		local sparkle = P_SpawnMobj(newx, newy, newz, MT_SPARKLETRAIL)
		sparkle.target = mo
		sparkle.destscale = mo.destscale
		sparkle.scale = mo.scale
		sparkle.color = colours[P_RandomRange(1, #colours)]
		sparkle.colorized = true
		tsrb2kr.FlipFromObject(sparkle, mo)
		if (i == 1 and mo.tsr_ultimatetimed) then sparkle.state = S_KARTINVULN_LARGE1 end
	end
	-- signpost sparkles but yellow/gold
	if (mo.tsr_ultimatetimed)	-- but only if you timed it!
		local newx = mo.x + mo.momx + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newy = mo.y + mo.momy + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newz = mo.z + mo.momz + (P_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)

		local sparkle = P_SpawnMobj(newx, newy, newz, MT_SIGNSPARKLE)
		sparkle.color = colours[P_RandomRange(1, #colours)]
		sparkle.colorized = true
		tsrb2kr.FlipFromObject(sparkle, mo)
	end
	
	-- ultimate depletion:
	-- count players:
	local numplayers = 0
	for p2 in players.iterate do
		if p2.mo and p2.mo.valid
			numplayers = $+1
		end
	end
	local pos = p.kartstuff[k_position]-1
	//local depletion = max(5, (4 - usingult) + (numplayers - pos)/2)
	local depletion = 3+(3-timed_ultimate)+((numplayers-pos)/4)

	p.tsr.teamultimate = $-depletion
	if (p.exiting) then p.tsr.teamultimate = min(1, $) end -- end ultimate after we finish

	if (p.tsr.teamultimate <= 0)
		p.kartstuff[k_sneakertimer] = 1
		p.tsr.teamultimate = 0
		mo.colorized = false
		mo.color = p.skincolor
		mo.tsr_ultimatespeed = nil
		mo.tsr_ultimatetimed = nil
		mo.tsr_ultimateon = nil
		mo.hf_overrideicon = nil	-- hitfeed support
		P_RestoreMusic(p)
	end
end

tsrb2kr.Ultimates_Main = function(p, ultcharge)
	p.tsr.teamultimate = $ or 0
	
    if (ultcharge >= 1000)    -- global ult charge for our team
    or (p.tsr.ultimatebuffer)    -- we reached ult charge once, we can keep it for now
		p.tsr.ultimatebuffer = true
		
		tsrb2kr.Ultimates_Decay(p, ultcharge)
		tsrb2kr.Ultimates_Signalling(p)
		tsrb2kr.Ultimates_Activate(p, ultcharge)
	end
	
	tsrb2kr.Ultimates_PlayerThinker(p)
end

tsrb2kr.Framework_HandleUltimates = function()
	server.tsr_server.ultimates = $ or {0, 0, 0, 0, 0}
	tsrb2kr.Ultimates_Freeplay()
	
	for p in players.iterate
		if not (p.tsr.team) then continue end
		local ultcharge = server.tsr_server.ultimates[p.tsr.team]
		tsrb2kr.Ultimates_HUDVariables(p)
		tsrb2kr.Ultimates_FillMessages(p, ultcharge)
		tsrb2kr.Ultimates_FullMeter(p, ultcharge)
		tsrb2kr.Ultimates_Main(p, ultcharge)
	end
end

tsrb2kr.Ultimates_PlayerDeath = function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.tsr_ultimateon) then return end
	
	mo.player.tsr.teamultimate = 0
end

addHook("MobjThinker", function(boostflame)
	if not (boostflame.target and boostflame.target.valid) then return end
	if not (boostflame.target.tsr_ultimateon) then return end
	
	-- make sure it's in the boostflame state while ultimating
	if (boostflame.state != S_BOOSTFLAME) then boostflame.state = S_BOOSTFLAME end
	boostflame.tics = boostflame.target.player.tsr.teamultimate
end, MT_BOOSTFLAME)
addHook("MobjThinker", function(fast)
	if (fast.target)
		if ((fast.target.player) and fast.target.tsr_ultimateon)
		and (fast.state == S_FASTLINE1)
			local colours = {SKINCOLOR_YELLOW, SKINCOLOR_GOLD, SKINCOLOR_SUPER5}	-- possible colours

			fast.color = colours[P_RandomRange(1, #colours)]
			fast.colorized = true
			fast.scale = fast.target.scale*11/10
		elseif (fast.target.type == MT_SPB) -- might as well handle spb stuff here too
		and (fast.target.tsr_spbteam)
			fast.color = tsrb2kr.ReturnTeamColor(fast.target.tsr_spbteam)
			fast.colorized = true
		end
	end
end, MT_FASTLINE)

tsrb2kr.Ultimates_ShouldDamage = function(p, inflictor, source)
	local mo = p.mo
	if not (mo and mo.valid) then return nil end
	if not (mo.tsr_ultimateon) then return nil end

	K_DoInstashield(p)	-- nu huh
	return false
end

tsrb2kr.Ultimates_DamagePlayers = function(mo, mo2)
	if not (mo and mo.valid) then return end
	if not (mo2 and mo2.valid) then return end
	if (mo2.type != MT_PLAYER) then return end

	if not (mo.tsr_ultimateon) then return end
	if (mo2.tsr_ultimateon) then return end	-- mo2 is using their ult, don't meddle

	local p2 = mo2.player	-- check for mo2's properties
	if (p2.kartstuff[k_growshrinktimer] > 0)
	or (p2.kartstuff[k_invincibilitytimer] > 0)
	or (p2.kartstuff[k_squishedtimer])
	or (p2.kartstuff[k_spinouttimer])
	or (p2.powers[pw_flashing])
		return
	end
	
	-- friendlyfire
	local p = mo.player
	if (p.tsr.team and p2.tsr.team)
	and (p.tsr.team == p2.tsr.team)
	and not CV_FindVar("friendlyfire").value
		return
	end
	
	if ((mo.z + mo.height >= mo2.z) and (mo.z <= mo2.z + mo2.height))
		P_DamageMobj(mo2, mo, mo, 1)
		-- let's make it EVEN WORSE:
		mo2.momz = $*5/2
		mo2.momx = $*5/2
		mo2.momy = $*5/2	-- :lol:

		-- fill our gauge (1/4 of the gauge)
		p.tsr.teamultimate = min(1000, $+250)
		S_StartSound(nil, sfx_ncspec, p)
	end
end

tsrb2kr.Ultimates_DamageHazards = function(mo, mo2)
	if not (mo and mo.valid) then return end
	if not (mo2 and mo2.valid) then return end
	if not (mo2.health) then return end	-- they need to be alive
	if (mo2.player) then return end -- this is for objects!
	
	if not (mo.tsr_ultimateon) then return end	-- we need to be ulting
	
	-- check if we can BREAK them
	local validObject = false
	
	local acceptedTypes = {
	MT_BLUEROBRA_HEAD, MT_BLUEROBRA_JOINT,	-- both head + target
	MT_SMK_PIPE, MT_SMK_THWOMP, -- SMK thwomp
	//MT_SMK_MOLE, -- SMK mole
	}
	for i = 1, #acceptedTypes
		if (mo2.type == acceptedTypes[i])
			validObject = true
			break
		end
	end
	if not (validObject) then return end
	
	-- check if we're colliding, then do stuff
	if ((mo.z + mo.height >= mo2.z) and (mo.z <= mo2.z + mo2.height))
		local killmo = (mo2.type == MT_BLUEROBRA_JOINT) and mo2.target or mo2
		P_KillMobj(killmo, mo, mo)
	end
end

tsrb2kr.Ultimates_MobjCollide = function(mo, mo2)
	tsrb2kr.Ultimates_DamagePlayers(mo, mo2)
	tsrb2kr.Ultimates_DamageHazards(mo, mo2)
end

tsrb2kr.Ultimates_EggboxCollision = function(egg, mo)
	if not (egg and egg.valid) then return end -- bruh
	if not ((mo and mo.valid) and mo.player) then return end -- make sure it's a player

	if (mo.tsr_ultimateon) then return true end
end
addHook("TouchSpecial", tsrb2kr.Ultimates_EggboxCollision, MT_EGGMANITEM)
addHook("TouchSpecial", tsrb2kr.Ultimates_EggboxCollision, MT_EGGMANITEM_SHIELD)

addHook("TouchSpecial", function(mole, mo)
	if not (mole and mole.valid) then return end -- bruh
	if not ((mo and mo.valid) and mo.player) then return end -- make sure it's a player
	
	if (mo.tsr_ultimateon) then P_KillMobj(mole, mo, mo) return true end
end, MT_SMK_MOLE)

addHook("MobjMoveCollide", function(mo, s)
	if not (mo.tsr_ultimateon) then return end
	if not (mo.player.tsr.inputs[BT_BRAKE]) then return end
	
	if (s and s.valid) and (s.flags & MF_SPRING)
	and ((mo.z + mo.height*2) >= s.z) and (mo.z <= (s.z + s.height/2))
		if not (mobjinfo[s.type].damage) then return end -- only diagonal springs should have damage set
		if not ((mobjinfo[s.type].damage/FRACUNIT) >= 26) then return end	-- blue springs destroyed us all
		
		local speed = (mobjinfo[s.type].damage/FRACUNIT)*3/2
		mo.player.speed = speed*mo.scale
	end
end, MT_PLAYER)