-- here we make everything WORK
addHook("MapLoad", tsrb2kr.Framework_Unload)

addHook("ThinkFrame", do
	server.tsr_tourneyrotation = $ or {}	-- make sure this is always going
	server.tsr_tourneyblacklist = $ or {}	-- this too
	if not (G_RaceGametype()) then return end	-- no, don't do this to battle
	
	tsrb2kr.Framework_SetupNamespaces()
	for p in players.iterate 
		local mo = p.mo
		tsrb2kr.Framework_Inputs(p)
		if (mo and mo.valid) then p.mo.hf_overridenamecolor = tsrb2kr.ReturnTeamColor(p.tsr.team) end	-- hitfeed support
	end
	
	-- tourney mode has it's own mode
	tsrb2kr.Framework_TourneyMode()
	if (server.tsr_server.tourneymode) then return end
	
	if not (leveltime >= 105) then return end	-- 105 is the point where we start doing things
	if (hitfeed) then HF_OverrideLocation(95) end	-- hitfeed support	
	tsrb2kr.Framework_ColourItems()
	tsrb2kr.Framework_HandleTeams()
	tsrb2kr.Framework_HandleTransfers()
	tsrb2kr.Framework_HandleUltimates()
	tsrb2kr.Framework_ResultHandler()
	for p in players.iterate
		local mo = p.mo
		
		tsrb2kr.Framework_HandleSlingshots(p)
		tsrb2kr.Framework_HandleSkimboosts(p)
		tsrb2kr.Framework_HandleRivals(p)
		if (mo and mo.valid) then tsrb2kr.Framework_JawzTargeting(mo) end
	end
end)

hud.add(function(v, p, c)
	if not (server.tsr_server) then return end	-- we NEED this
	if not (G_RaceGametype()) then return end
	
	tsrb2kr.HUD_TourneyMode(v, p, c)
	if (server.tsr_server.tourneymode) then return end
	tsrb2kr.Framework_HUD(v, p, c)
end)

addHook("MobjDeath", function(mo)
	if not (G_RaceGametype()) then return end
	tsrb2kr.Slingshots_PlayerDeath(mo)
	tsrb2kr.Ultimates_PlayerDeath(mo)
end, MT_PLAYER)

tsrb2kr.Framework_MobjCollide = function(mo, mo2)
	if not (G_RaceGametype()) then return end
	
	tsrb2kr.Ultimates_MobjCollide(mo, mo2)
	return tsrb2kr.Items_TeamColliding(mo, mo2)
end
addHook("MobjCollide", tsrb2kr.Framework_MobjCollide, MT_PLAYER)
addHook("MobjMoveCollide", tsrb2kr.Framework_MobjCollide, MT_PLAYER)

tsrb2kr.Framework_ShouldDamage = function(p, inflictor, source)
	if not (G_RaceGametype()) then return end
	
	if (tsrb2kr.Ultimates_ShouldDamage(p, inflictor, source) != nil)
		return tsrb2kr.Ultimates_ShouldDamage(p, inflictor, source)
	end
	if (tsrb2kr.Items_FriendlyFire(p, inflictor, source) != nil)
		return tsrb2kr.Items_FriendlyFire(p, inflictor, source)
	end
end
addHook("ShouldSpin", tsrb2kr.Framework_ShouldDamage, MT_PLAYER)
addHook("ShouldSquish", tsrb2kr.Framework_ShouldDamage, MT_PLAYER)
addHook("ShouldExplode", tsrb2kr.Framework_ShouldDamage, MT_PLAYER)