-- setting up and removing the player namespaces
tsrb2kr.Framework_SetupNamespaces = function()
	-- make sure player namespaces are setup
	for p in players.iterate
		if (p.tsr) then continue end
		p.tsr = {}
	end
	-- server var namespace
	server.tsr_server = $ or {}
	server.tsr_server.teams = $ or {{}, {}, {}, {}, {}}
end

tsrb2kr.Framework_Unload = function()
	-- reset inttime
	if (server.tsr_server.inttime)
		COM_BufInsertText(server, "inttime "..server.tsr_server.inttime)
	end
	
	-- reset hud elements
	local trivialHUD = {"time", "minirankings", "item", "speedometer", "position", "gametypeinfo", "check"}
	for i = 1, #trivialHUD do hud.enable(trivialHUD[i]) end
	if (server.tsr_server.tourneymode) then hud.enable("textspectator") end
	
	-- unload teams
	for p in players.iterate
		if not (p.tsr) then continue end
		
		if (p.tsr.oldskincolor)
			TSR_SmartSetColor(p, false, p.tsr.oldskincolor)
			p.skincolor = p.tsr.oldskincolor

			p.tsr.oldskincolor = nil
		end
		
		p.tsr = nil
	end
	
	server.tsr_server = nil
	COM_BufInsertText(server, "karteliminatelast off")	-- no
	
	-- special tourneymode handling
	tsrb2kr.TourneyMode_MapLoad()
end