-- load tsrb2kr.cfg when the pk3 is added to load settings!
freeslot("sfx_tscrea", "sfx_tsload")
local loaded = false

-- store commands, we'll iterate through this to create a config if necessary
local commands = {
	{tsrb2kr.cv_t1c, "Changes Team 1's colour"}, 
	{tsrb2kr.cv_t2c, "Changes Team 2's colour"}, 
	{tsrb2kr.cv_t3c, "Changes Team 3's colour"},
	{tsrb2kr.cv_t4c, "Changes Team 4's colour"}, 
	{tsrb2kr.cv_t5c, "Changes Team 5's colour"}, 
	{tsrb2kr.cv_tc, "Makes every player their respective team colour"},
	{tsrb2kr.cv_tyc, "Display controls during tourney mode setup"}
}

addHook("ThinkFrame", function()
    if (loaded) then return end

	-- set this to true, we dont wanna do this again.
	loaded = true
	
    if not consoleplayer then return end
	
	-- create/load the config!
	local config = io.open("tsrb2kr.cfg", "r")
	if not (config)	-- no config? create one.
		config = io.open("tsrb2kr.cfg", "w")	-- create it.
			
		-- write all our defaults to it.
		for i = 1, #commands
			local command = commands[i][1]
			local command_desc = commands[i][2]
				
			config:write(command.name.." "..command.defaultvalue.." // "..command_desc.."\n")
		end
			
		CONS_Printf(consoleplayer, "\x83NOTICE:\x80 tsrb2kr.cfg not found, created a config in \x82/luafiles\x80.")
		S_StartSound(nil, sfx_tscrea, consoleplayer)
	else	-- we got a config, load it!
		for line in config:lines()
			COM_BufInsertText(consoleplayer, line)
		end
		CONS_Printf(consoleplayer, "\x83NOTICE:\x80 Successfully loaded tsrb2kr.cfg!")
		S_StartSound(nil, sfx_tsload, consoleplayer)
	end
	config:close()
end)